package session02;

public class StartVsRun {

	public static void main(String[] args) {
		System.out.println("main thread start " + Thread.currentThread().getName());

		PrintingThread tHi = new PrintingThread("Hi");
		PrintingThread tBye = new PrintingThread("Bye");

		// change start to run
		tHi.start();
		tBye.start();

		try {
			tHi.join();
			tBye.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}

		System.out.println("main thread end " + Thread.currentThread().getName());
	}

}

class PrintingThread extends Thread {
	private String str; // thread local data

	public PrintingThread(String str) {
		this.str = str;
	}

	@Override
	public void run() {
		while(true) {
			System.out.println(Thread.currentThread().getName() + " " + str);
		}
	}
}
